controllers/SiteController.php
<?php

namespace app\controllers;
use yii\data\SqlDataProvider;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use yii\data\ActiveDataProvider;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /*
     * Creado esta accion
     */
    
    public function actionCrud(){
        return $this->render('gestion');
    }
    
    
    public function actionConsulta1a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("edad")->distinct(),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Consulta las edadades de los ciclistas",
            "sql"=>"select distinct edad from ciclista",
        ]);
    }
    
    public function actionConsulta1(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand('SELECT count(DISTINCT c.edad) FROM ciclista c' )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> 'SELECT DISTINCT c.edad FROM ciclista c' ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>5,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Consulta las edadades de los ciclistas",
            "sql"=>"select distinct edad from ciclista",
        ]);
                
    }
    
    public function actionConsulta2a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("edad")->distinct()->where("nomequipo='Artiach'"),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Listar las edadades de los ciclistas de Artiach",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach'",
        ]);
    }
    
     public function actionConsulta2(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT count(DISTINCT edad) FROM ciclista WHERE nomequipo='artiach'" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT edad FROM ciclista WHERE nomequipo='artiach'" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>5,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Consulta las edadades de los ciclistas de Artiach",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach'",
        ]); 
        
    }
    
    public function actionConsulta3a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("edad")->distinct()
                ->where("nomequipo='artiach' OR nomequipo='Amore vita'"),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"listar las edadades de los ciclista del equipo de Artiach o de Amore Vita",
            "sql"=>"SELECT DISTINCT edad FROM ciclista WHERE nomequipo='artiach' OR nomequipo='Amore vita'",
        ]);
    }
    
     public function actionConsulta3(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT count(DISTINCT edad) FROM ciclista WHERE nomequipo='artiach' OR nomequipo='Amore vita'" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT edad FROM ciclista WHERE nomequipo='artiach' OR nomequipo='Amore vita'" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>5,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"listar las edadades de los ciclista del equipo de Artiach o de Amore Vita",
            "sql"=>"SELECT DISTINCT edad FROM ciclista WHERE nomequipo='artiach' OR nomequipo='Amore vita'",
        ]); 
    }
    
    public function actionConsulta4a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("dorsal")->distinct()
                ->where("edad < 25 or edad >30"),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad sea menor 25 o mayor que 30",
            "sql"=>"SELECT dorsal FROM ciclista WHERE edad < 25 or edad >30",
        ]);
    }
    
     public function actionConsulta4(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT count(DISTINCT dorsal) FROM ciclista WHERE edad < 25 or edad >30" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT dorsal FROM ciclista WHERE edad < 25 or edad >30" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>5,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad sea menor 25 o mayor que 30",
            "sql"=>"SELECT dorsal FROM ciclista WHERE edad < 25 or edad >30",
        ]);
    }
    
       public function actionConsulta5a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("dorsal")->distinct()
                ->where("edad  >= 28 AND edad <=32 AND nomequipo='Banesto'"),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 5",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad esta entre 28 y 32 y además que solo sean de Banesto",
            "sql"=>"SELECT dorsal FROM ciclista WHERE edad BETWEEN 28 AND 32 AND nomequipo='Banesto'",
        ]);
    }
    
     public function actionConsulta5(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT count(DISTINCT dorsal) FROM ciclista WHERE edad < 25 and edad <30" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT dorsal FROM ciclista WHERE edad < 25 and edad <30" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>5,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 5",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad esta entre 28 y 32 y además que solo sean de Banesto",

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php

use yii\helpers\Html;

echo Html::a('Ciclistas',
        ['ciclista/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Etapas',
        ['etapa/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Equipos',
        ['equipo/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Lleva',
        ['lleva/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Maillot',
        ['maillot/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Puerto',
        ['puerto/index'],
        ['class' => 'btn btn-primary btn-large']
        );



?>

views/site/index.php
<?php
use yii\bootstrap\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>

<div class="site-index">

    <div class="jumbotron">
        <h1>consultas de seleccion 1</h1>
pplication
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">

        <div class="row">
            <!-- primera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 1</h3>
                      <p>Listar las edadades de ciclists sin repetidos</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta1a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta1'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
            <!-- segunda consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 2</h3>
                      <p>Listar las edadades de ciclists de Artiach</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta2a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta2'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             <!-- tercera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 3</h3>
                      <p>Listar las edadades de ciclists de Artiach o de Amore Vita</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             
              <!-- cuarta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 4</h3>
                      <p>Listar los dorsales de los ciclistas cuya edad sea menor 25 o mayor que 30</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
               <!-- quinta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 5</h3>
                      <p>Listar los dorsales de los ciclistas cuya edad esta entre 28 y 32 y además que solo sean de Banesto</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta5a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta5'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
               <!-- sexta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 6</h3>
                      <p>Listar nombre de los ciclistas que el número de carácteres sea mayor que 8</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta6a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta6'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
               
              <!-- septima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 7</h3>
                      <p>Listar el nombre y el dorsal de todos los ciclistas mostrando un campo denominao nombre mayúscula</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta7a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta7'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- octava consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 8</h3>
                      <p>Listar los ciclistas que han llevdo el maillot MGE (amarillo) en alguna etapa</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- novena consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 9</h3>
                      <p>Lista el nombre de los puertos cuya altura sea mayor 1500</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta9a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta9'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- decima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 10</h3>
                      <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto curya pendiente se mayor que 8 o cuya altura este entre 1800 y 3000</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta10a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta10'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- undecima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 11</h3>
                      <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 y cuya altura este entre 1800 y 3000</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta11a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta11'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
        </div>

    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>


 <div class="jumbotron">
        <h1><?= $titulo?></h1>
        <p class="lead"><?=$enunciado?></p>
            <div class="well"> 
            <?= $sql?>
            </div>
    </div>
    
    
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
                
    ]);?>